package cicaprojekt;

import java.util.Stack;

public class Scale extends Field {
	private Gate gateConnected;
	private Stack<Pickable> itemsOnTile;
	private int threshold;
	private int weight;
	
	public Scale(Gate gate, int _threshold){
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.Scale(" + gate + ")");
		gateConnected = gate;
		threshold = _threshold;
		itemsOnTile = new Stack<Pickable>();
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.Scale()");
		Menu.removeTab();
		
	}
	
	public void onEntry() {
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.onEntry()");
		gateConnected.setOpen(true);
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.onEntry()");
		Menu.removeTab();
	}
	
	public void onExit() {
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.onExit()");
		gateConnected.setOpen(false);
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.onExit()");
		Menu.removeTab();
	}

	@Override
	public Pickable removeItemFromTile() {
		weight -= itemsOnTile.peek().weight();
		stackChanged();
		return itemsOnTile.pop();
	}

	@Override
	public void setItemOnTile(Pickable item) {
		itemsOnTile.push(item);
		weight += item.weight();
		stackChanged();
	}

	public void spawnStargate(cicaprojekt.Stargate stargate, Direction direction) {
		Menu.addTab();
		System.out.println(">" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.spawnStarGate(stargate," + direction.name() + ")");
		adjacentTile.get(direction).spawnStargate(stargate, direction);
		System.out.println("<" + "[" + ":" + this.getClass().getSimpleName() + "]" + Menu.tabulator + "Scale.spawnStarGate()");
		Menu.removeTab();
	}

	private void stackChanged() {
		if(weight > threshold)
			gateConnected.setOpen(true);
		else
			gateConnected.setOpen(false);
	}
}
